#include <stdio.h>
#include <stdlib.h>
// structs anonimos
struct {int x; int y;} punto;

// typedef: alias en compilacion
// se reemplaza el primer parametro por el segundo al ser compilado el programa, no es lo mismo que preprocessing ya que preprocessing solo reemplaza valores
// typedef realiza un cambio mas profundo y solo sirve para tipos de datos. Preprocessing sirve para cualquier cosa
typedef struct {int x; int y;} point; // typedef de un struct anonimo

//typedef struct node {int val; list next;} list; // esta MALO, ya que al tratar de definir struct node aun no se define list y crea error.

typedef struct node {int val; struct node *next;} list; // esto si funciona
// el segundo parametro es un puntero ya que todas las estructuras son guardadas como punteros de memoria, podrian considerarse arreglos especiales

// esto tambien
typedef struct node2 *list2; // list2 es un puntero, asi que debemos pedir la memoria para este con malloc... vivira en todo el programa, no solo la funcion
struct node2 {int val; list2 next;}; // no dejamos next como puntero ya que list2 lo lleva implicito

// esto tambien
typedef struct node3 list3; // en este caso list3 no es un puntero, asi que si hacemos list3 x; tenemos un objeto solo residente en la memoria de una funcion
struct node3 {int val; list3 *next;}; // ahora SI dejamos next como puntero ya que list2 NO lo lleva implicito

/* Funciones by value y by reference */
int choose(list3 x, list2  y, list3 *z, int *w)
{
	/* list3 no es un puntero por lo que x esta siendo pasada como valor solamente*/
	/* para acceder sus campos debemos usar un . en vez de un -> */
	printf("x.val = %d\n", x.val);
	printf("(&x)->val = %d\n", (&x)->val);
		
	//printf("x->val = %d\n", x->val);	como x fue pasado por valor... esto no funcionara
	//printf("y.val = %d\n", y.val); // como y es un pasado por referencia (aun cuando no salga * en y), esto tampoco funciona	
	//printf("z.val = %d\n", z.val); // como z es un pasado por referencia, esto tampoco funciona

	printf("(*y).val = %d\n", (*y).val); 
	printf("y->val = %d\n", y->val);

	printf("(*z).val = %d\n", (*z).val); // (*z).val = z->val... *z toma el objeto referenciado, asi que lo puedo tratar como si fuese por valor y no por referencia
	printf("z->val = %d\n", z->val);	 
	
	printf("\n# cambiamos valores en choose con la sintaxis normal, x.val = 3, y->val = 6, z->val = 9\n");
	x.val = 3;
	y->val = 6;	
	z->val = 9;
	printf("x.val = %d\n", x.val);
	printf("(&x).val = %d\n", (&x)->val);
	printf("y->val = %d\n", y->val);
	printf("(*y).val = %d\n", (*y).val);
	printf("z->val = %d\n", z->val);
	printf("(*z).val = %d\n", (*z).val);
	
	printf("\n# cambiamos valores en choose con la sintaxis alternativa, (&x)->val = 4, (*y).val = 7, (*z).val = 10\n");		
	(&x)->val = 4;
	(*z).val = 7;
	(*z).val = 10;
	printf("x.val = %d\n", x.val);
	printf("(&x).val = %d\n", (&x)->val);
	printf("y->val = %d\n", y->val);
	printf("(*y).val = %d\n", (*y).val);
	printf("z->val = %d\n", z->val);
	printf("(*z).val = %d\n", (*z).val);
	
	*w = 2500; // no debo poner w = 2500, ya que ahi estoy diciendole al puntero que apunte a 2500!!! *w = 2500 toma el entero referenciado y le asigna 2500
	
	return 0;
}
int main()
{
	int *w;
	
	list3 x; // no puntero
	x.val = 2450003;

	list3 *z; // si puntero
	z = (list3 *)malloc(sizeof(list3)); //malloc!! y tambien casting... importante
	z->val = 123456;
	
	list2 y; // si puntero, aunque no salga el * viene implicito en el typedef de list2
	//y.val = 67890; // error de compilacion!
	//y->val = 67890; // error en runtime!
	y = (list2)malloc(sizeof(list2)); //malloc!! y tambien casting... importante	
	y->val = 67890; // error!

	w = (int *)malloc(sizeof(int));
	choose(x, y, z, w); // si no hago malloc para w antes de llamar la funcion, me tirara error de runtime ya que no tendra donde escribir w!
	printf("\n\n==== luego de choose =====\n");

	printf("x.val = %d\n", x.val);
	printf("(&x).val = %d\n", (&x)->val);
	printf("y->val = %d\n", y->val);
	printf("(*y).val = %d\n", (*y).val); // aqui solo el valor de y cambio... no el de x ya que fue pasado por valor, y por referencia	
	printf("z->val = %d\n", z->val);
	printf("(*z).val = %d\n", (*z).val); // aqui solo el valor de z cambio... no el de x ya que fue pasado por valor, z por referencia
	printf("w = %d\n", *w); // w cambio!!! 

	//liberamos lo que pedimos con malloc para que no haya memory leaks!!!
	free(y);
	free(z);
	free(w);
	
	goto label;

	return 0;

label:
printf("\n=== me salte el return con un goto ===\n");
return 0;
}